
from twisted.python import components

"""
utilities to be compatible with both Twisted-1.3 and 2.0

implements. Use this like:
    from buildbot.tcompat import implements
    class Foo:
        if implements:
            implements(IFoo)
        else:
            __implements__ = IFoo,
        
Interface:
    from buildbot.tcompat import Interface
    class IFoo(Interface)

providedBy:
    from buildbot.tcompat import providedBy
    assert providedBy(obj, IFoo)
"""

# does our Twisted use zope.interface?
if hasattr(components, "interface"):
    # yes
    from zope.interface import implements
    from zope.interface import Interface
    def providedBy(obj, iface):
        return iface.providedBy(obj)
else:
    # nope
    implements = None
    from twisted.python.components import Interface
    providedBy = components.implements
